#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <limits.h>
#include <time.h>
#include <vector>

#include "TNear.h"
#include "v.h"

int main ( )
{
   CNearTree <v> vTree;
   v vBest = DBL_MAX;
   long i,j,k;
   const long lMaxRow = 10;
   std::vector <v> vReturn;

   srand( (unsigned)time( NULL ) );  // use the current time to seed the
                              // random number generator
//---------------------------------------
// build up a library of points to search among
//---------------------------------------
   for ( k=-1; k<=lMaxRow; k++ )
   {
      for ( j=-1; j<=lMaxRow; j++) 
      {
         for ( i= lMaxRow ; i>=-1;  i-- ) 
         {
            vTree.m_fnInsert( v((double)i, (double)j, (double)k) );
         }  // for i
      }     // for j
   }        // for k
    cout
      << endl;

//---------------------------------------
//   Done building the tree; now try a retrieval
//---------------------------------------

   double   dRad = 0.6;
   long lReturn;
   for ( i=0;  i<10; i++ )
   {
      dRad += 0.05;
      double x = rand( ) * double( lMaxRow ) / RAND_MAX;
      double y = x;
      double z = ( 1.25 * double(lMaxRow) - 1.5 * x );
      v vSearch( x, 0.5*(x+y), z );
      cout
         << "Trial " << i << " from probe point " << vSearch << endl;




// find the nearest point to vSearch
      if ( vTree.m_bfnNearestNeighbor( dRad, vBest, vSearch ) )
      {
         cout
            << " Closest distance " << (double) ( vSearch - vBest ) << " to " << vBest << endl;
      }
      else
      {
         cout
            << " ***** nothing within " << dRad << " of " << vSearch << endl;
      }

// find the farthest point from vSearch
      if ( vTree.m_bfnFarthestNeighbor ( vBest, vSearch ) )
      {
         cout 
            << " Farthest distance " << (double) ( vSearch - vBest ) << " to " << vBest << endl;
      }
      else
      {
         cout << " No Farthest object found" << endl;
      }

// search for all points within a "sphere" out to radius dRad
      if ( ( lReturn = vTree.m_lfnFindInSphere( dRad, vReturn, vSearch )) > 0 ) 
      {
         cout << " Returned " << lReturn << " items within " << dRad << " of "<< vSearch << endl;
         std::vector <v>::iterator iv;
         for ( iv=vReturn.begin( ); iv<vReturn.end( ); iv++ )
         {
            cout << "\t" << *iv << endl;
         }
      }

      cout << " -------------------------------------------------------------"<<endl;
   }  // for i

   vTree.CNearTree<v>::~CNearTree( );

   return ( EXIT_SUCCESS );
}