//
// RandomMin.h: interface for the RandomMin and RandomMax classes.
#if !defined(RANDOMMIN_H)
#define RANDOMMIN_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <vector>
#include <list>
using namespace std;

const double ROUNDOFF_ERR = 0.000001;

int randomNum(int maxValPlusOne);

class ValueGroup
{
public :
   double m_val  ;
   vector <int> m_index;
   ValueGroup(){m_val=0;};
   ValueGroup(int index, double val)
      {m_val=val;m_index.push_back(index);};
   ValueGroup(const ValueGroup &src)
      { *this =  src; }
   ValueGroup& operator = (const ValueGroup& rhs) 
      {m_val=rhs.m_val;m_index = rhs.m_index;return *this;};
};

class RandomMin
{
protected:
   int               m_sampleSize;
   double            m_tol;
   list <ValueGroup> m_vgList;
   int               m_sampleCnt;
  
public:
   RandomMin();
   void           RoundoffTolerance( double tol) {m_tol = tol;};
   void           Initialize(int sampleSize);
   virtual void   Compare( int index, double value);
   int            RandomSelectIndex();
};

class RandomMax:public RandomMin
{
public:
      void Compare( int index, double val);
};

#endif
